------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g  12c                                              --
--                                                CAPTULO 01 - NOVAS FEATURES ORACLE 12C SQL TUNING                                                --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047


Contedo

Controlling User Access

    Differentiate system privileges from object privileges
    Grant privileges on tables and on a user
    View privileges in the data dictionary  
    Grant roles  
    Distinguish between privileges and roles 

-- Usurio

Para realizarmos qualquer ao em um servidor de banco de dados  necessrio ter um usurio com
determinados privilgios de acesso ao servidor. No banco de dados Oracle  existem diferentes
privilgios que podem ser concedidos aos usurios, e gerenciar os privilgios individualmente pode
se tornar uma tarefa extremamente cansativa. Para facilitar essa tarefa de gerenciamento,
normalmente, utilizamos atribuies para agrupar os privilgios.
Geralmente temos vrios usurios conectados ao banco de dados e executando aes concorrentes e
simultneas. Para evitar que um usurio especfico consuma em excesso os recursos disponveis
(CPU, E/S, memria), o que prejudicaria os demais usurios, o banco de dados Oracle  fornece
um mecanismo, chamado de perfil, para controlar o limite desses recursos que o usurio pode
utilizar.

Uma conta de usurio  identificada por um nome (de no mximo trinta caracteres) e est associado 
a somente um esquema, com o mesmo nome do usurio, no banco de dados. Os termos usurio e
esquema podem ser usados alternadamente em um ambiente Oracle, mas nem sempre querem 
dizer a mesma coisa. Um usurio  o nome utilizado para estabelecer uma conexo com o banco de
dados. Um esquema  um conjunto de objetos de propriedade do usurio: tabelas, ndices,
seqncias, vises, entre outros (WATSON, 2010).

O comando utilizado para criar um usurio  o CREATE USER. Esse comando possui somente dois
parmetros obrigatrios: o nome e a senha do usurio. No entanto,  boa prtica definir vrios 
outros parmetros para a conta do usurio (WATSON, 2010). Abaixo, conforme apresentando por
BRYLA & LONEY (2009), os principais parmetros utilizados quando um usurio  criado

Parmetros

Nome do usurio
Especifica o nome que identifica a conta do usurio. Ele pode ter
at 30 caracteres e no pode ser uma palavra reservada a menos
que ela esteja entre aspas (o que no  recomendado).


IDENTIFIED BY senha
Especifica a senha do usurio para acesso ao banco de dados. 


DEFAULT TABLESPACE
Especifica o tablespace padro onde os objetos permanentes da
conta do usurio sero criados, exceto, quando o tablespace 
explicitamente especificado durante a criao dos objetos.

TEMPORARY TABLESPACE 
Especifica o  tablespace onde os segmentos temporrios, da 
conta do usurio, sero criados durante as operaes de
classificao, criao de ndices, etc. 

QUOTA
Especifica a quantidade de espao, ou tamanho, permitido para 
os objetos criados no tablespace especificado. O tamanho pode
ser em kilobytes(K) ou em megabytes(M).

PROFILE 
Especifica o perfil atribudo a este usurio. Ele ser discutido
mais adiante nesse artigo. Se um perfil no for especificado, o
perfil utilizado ser o DEFAULT. 

PASSWORD EXPIRE
Especifica que aps o primeiro logon, o usurio deve alterar a
senha.

ACCOUNT {LOCK | UNLOCK} 
Especifica se a conta do usurio est bloqueada (LOCK) ou
desbloqueada (UNLOCK). Por padro, a conta do usurio ser
criada desbloqueada.


Exemplo do comando para criar a conta do usurio

CREATE USER DEMO  
IDENTIFIED BY 123456
ACCOUNT UNLOCK 
DEFAULT TABLESPACE USERS
TEMPORARY TABLESPACE TEMP;

Exemplo do comando para alterar a conta do usurio
ALTER USER DEMO  
IDENTIFIED BY 9998877
ACCOUNT LOCK;
...
..

Exemplo do comando para remover a conta do usurio
DROP USER DEMO;


Perfis

Um processo de usurio pode consumir, em excesso, recursos como CPU, espao em disco ou
largura de banda de E/S (Entrada / Sada). Como esses recursos geralmente so limitados, o Oracle 
 possui um mecanismo para limitar e controlar a quantidade desses recursos que os processos do 
usurio podem consumir. Alm disso, os perfis tambm podem ser usados como um mecanismo de
autorizao para controlar como as senhas de usurios so criadas, reutilizadas e validadas.


Um perfil tem dupla funo: impor uma poltica para a senha da conta de usurio (limites para as
senhas) e restringir os recursos que uma sesso pode ocupar (limites para os recursos). No banco de
dados Oracle  os limites para as senhas so sempre obrigatrios; e os limites para os recursos s
so obrigatrios se o parmetro de instncia RESOURCE_LIMIT estiver como TRUE (por padro
ele  FALSE). Todas as contas de usurios tm um perfil, por padro, chamado de DEFAULT. O
perfil DEFAULT pode ser ajustado, e a alterao ser imediatamente aplicada a todos os usurios
com o perfil. Perfis adicionais podem ser criados e atribudos explicitamente a certos usurios
(WATSON, 2010). A seguir  descrito os limites apresentados:


FAILED_LOGIN_ATTEMPTS
Especifica o nmero de erros consecutivos em uma senha antes
de a conta do usurio ser bloqueada. Se a senha correta for
fornecida antes desse limite ser alcanado, o contador  
redefinido como zero.


PASSWORD_LOCK_TIME
Especifica o nmero de dias que uma conta ficar bloqueada 
depois que o FAILED_LOGIN_ATTEMPTS for atingido. 

PASSWORD_LIFE_TIME 
Especifica o nmero de dias antes de uma senha expirar. Ela 
ainda poder ser usada por algum tempo aps a expirao,  
dependendo da configurao utilizada


PASSWORD_GRACE_TIME
Especifica o nmero de dias depois do primeiro logon bem-
sucedido aps a senha ter expirado. A senha antiga ainda pode
ser usada durante esse perodo. 

PASSWORD_REUSE_TIME
Especifica o nmero de dias antes que uma senha possa ser 
reutilizada.


PASSWORD_REUSE_MAX
Especifica o nmero de vezes que uma senha pode ser
reutilizada.
 
PASSWORD_VERIFY_FUNCTION 	
Especifica o nome de uma funo a ser executada sempre que 
uma senha for alterada. A finalidade da funo deve ser verificar
se a nova senha tem um grau de complexidade adequado

SESSIONS_PER_USER
Especifica o nmero de logins concorrentes que podem ser feitos
 mesma conta de usurio. Sesses que tenta fazer login com o 
mesmo nome de usurio aps esse limite ser alcanado sero 
bloqueadas.

CPU_PER_SESSION
Especifica o tempo de CPU, em centissegundos, que um
processo de servidor de uma sesso pode ser usado antes da
sesso ser foradamente terminada.

CPU_PER_CALL

Especifica o tempo de CPU, em centissegundos, que um
processo de servidor de uma sesso pode ser usado para executar 
uma instruo SQL, antes de a instruo ser foradamente 
terminada. 
 

LOGICAL_READS_PER_SESSION	Especifica o nmero de blocos que podem ser lidos por uma
sesso (independentemente de eles estarem no cache de buffer
do banco de dados ou lidos no disco) antes que a sesso seja 
foradamente terminada. 


LOGICAL_READS_PER_CALL
Especifica o nmero de blocos que podem ser lidos por uma
nica instruo SQL (independentemente de eles estarem no 
cache de buffer do banco de dados ou lidos no disco) antes que a 
instruo seja foradamente terminada. 

PRIVATE_SGA 
Para sesses conectadas por meio da arquitetura de servidor
compartilhado, especifica o nmero, em kilobytes, que a sesso 
pode usar na SGA (System Global Area).

CONNECT_TIME
Especifica a durao mxima, em minutos, mxima de uma 
sesso antes de ser foradamente terminada.

IDLE_TIME
Especifica tempo mximo, em minutos, que uma sesso pode
ficar ociosa antes de ser foradamente terminada.

COMPOSITE_LIMIT
Especifica uma soma ponderada dos parmetros acima.
Geralmente utilizamos esse parmetro quando precisamos dar
flexibilidade e tolerncia s operaes executadas pelos
usurios, assim estamos limitando o usurio pelo uso ponderado

Exemplo para criar um perfil
CREATE PROFILE EXEMPLO LIMIT
CONNECT_TIME 120
FAILED_LOGIN_ATTEMPTS 8;

Exemplo para alterar um perfil

ALTER PROFILE EXEMPLO LIMIT
PASSWORD_LIFE_TIME 180
PASSWORD_GRACE_TIME 7
PASSWORD_REUSE_MAX UNLIMITED 
FAILED_LOGIN_ATTEMPTS 10
PASSWORD_LOCK_TIME 1; 

Exemplo para remover um perfil
DROP PROFILE EXEMPLO; 


PRIVILGIOS

Segundo WATSON (2010), em um banco de dados Oracle  no  possvel fazer nada sem o(s)
privilgio(s) correto(s). Um usurio no pode sequer conectar-se sem ter o privilgio para tal e, uma
vez que conectado, ele no pode fazer mais nada de til (ou perigoso) sem receber mais privilgios. 
Os privilgios so atribudos s contas de usurios com o comando GRANT e removidos atravs do
comando REVOKE. Na maioria das vezes que o usurio no possui privilgio para executar uma 
ao, o banco de dados Oracle  emite uma mensagem de advertncia semelhante a esta: ORA-
01031: Privilgios Insuficientes.

Privilgios de Sistemas -- ao que voce vai fazer no banco de dados.

ALTER SYSTEM
CREATE USER
CREATE SESSION
CREATE TABLE
SYSDBA 

Exemplo de como conceder um privilgio de sistema 
GRANT CREATE SESSION TO DEMO;

Exemplo de como retirar um privilgio de sistema 
REVOKE CREATE ANY TABLE FROM DEMO;

Privilgios de Objetos -- NIVEL DE UMA CAMADADE DADOS

ALTER
EXECUTE 
SELECT
INSERT 
DELETE
UPDATE

Exemplo de como conceder privilgios de objeto
GRANT SELECT ON hr.employees TO DEMO;
GRANT SELECT, INSERT, UPDATE ON hr.employees TO DEMO;

Exemplo de como retirar privilgios de objeto 
REVOKE UPDATE ON hr.employees FROM DEMO;

Estas so consultas teis para identificar quais so os privilgios de um determinado usurio em base Oracle:

1) Privilgios de sistema: select privilege from dba_sys_privs where grantee = 'DEMO';
2) Privilgios em tabelas: select privilege from dba_tab_privs where grantee = 'DEMO';


Atribuies ou ROLES --REGRAS
No contexto do banco de dados Oracle , uma atribuio (role em ingls)  conjunto de
privilgios de sistema e/ou privilgios de objeto que podem ser concedidos e revogados com uma 
unidade (WATSON, 2010).  

Tambm podemos dizer que uma atribuio  um grupo nomeado de privilgios, sejam eles de
sistema ou de objeto, ou uma combinao de ambos, que facilita a administrao dos privilgios

Exemplo para criar uma atribuio
CREATE ROLE FUNCNIVEL1;

Exemplo para conceder privilgios uma atribuio
GRANT CREATE SESSION TO FUNCNIVEL1;
GRANT CREATE TABLE TO FUNCNIVEL1;
GRANT CREATE VIEW TO FUNCNIVEL1;
GRANT CREATE PROCEDURE TO FUNCNIVEL1;
GRANT SELECT, UPDATE ON hr.employees TO FUNCNIVEL1;

Exemplo para atribuir uma atribuio a usurio
GRANT FUNCNIVEL1 TO DEMO;

Exemplo para excluir uma atribuio
DROP ROLE FUNCNIVEL1;


Para identificar quais so as ROLES e privilgios do usurio que voc est conectado, existem essas duas consultas, que so mais simples:
1) Roles do meu usurio: select * from session_roles;
2) Privilgios do meu usurio: select * from session_privs;
3) Roles concedidas ao usurio: select granted_role from dba_role_privs where grantee = 'DEMO';

-- consultar usuarios
SELECT username, default_tablespace, temporary_tablespace FROM dba_users WHERE username = 'DEMO';

-- WITH ADMIN OPTION -- o usuario que voce concedeu este parametro pode liberar acesso para outros usuarios igualmente

Views do Dicionrio de Dados:
 DBA_USERS - Descreve todos os usurios do Banco de Dados
 ALL_USERS - Lista os usurios visveis ao usurio atual, mas no os descreve
 USER_USERS - Descreve somente o usurio atual
 DBA_TS_QUOTAS - Descreve as quotas da Tablespace
 USER_TS_QUOTAS - Descreve as quotas da Tablespace
 USER_PASSWORD_LIMITS - Descreve os parmetros do perfil da senha que
so atribudos ao usurio
 USER_RESOURCE_LIMITS - Indica os limites do recurso para o usurio atual
 DBA_PROFILES - Indica todos os perfis e seus limites
 RESOURCE_COST - Lista o custo para cada recurso
 VSESSION - Lista a informao da sesso para cada sesso atual, inclu o
nome do usurio
 VSESSTAT - Lista as estatsticas da sesso do usurio
 PROXY_USERS - Descreve os usurios que podem assumir a identidade de
outros usurios 


-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos


1. What privilege should a user be given to log on to the Oracle server? Is this a system
privilege or an object privilege?
_________________________________________________________________
2. What privilege should a user be given to create tables? 
_________________________________________________________________
3. If you create a table, who can pass along privileges to other users in your table? 
_________________________________________________________________
4. You are the DBA. You create many users who require the same system privileges.
What should you use to make your job easier? 
_________________________________________________________________
5. What command do you use to change your password? 
_________________________________________________________________
6.	User21 is the owner of the EMP table and grants the DELETE privilege to User22
by using the WITH GRANT OPTION clause. User22 then grants the DELETE
privilege on EMP to User23. User21 now finds that User23 has the privilege and
revokes it from User22. Which user can now delete from the EMP table? 
_________________________________________________________________
7. You want to grant SCOTT the privilege to update data in the DEPARTMENTS table.
You also want to enable SCOTT to grant this privilege to other users. What command
do you use?
_________________________________________________________________

8. Grant another user query privilege on your table. Then, verify whether that user can
use the privilege.
Note: For this exercise, team up with another group. For example, if you are user
ora21, team up with another user ora22.
a. Grant another user privilege to view records in your REGIONS table. Include
an option for this user to further grant this privilege to other users.
b. Have the user query your REGIONS table.
c. Have the user pass on the query privilege to a third user (for example,
ora23).
d. Take back the privilege from the user who performs step b.  
Note: Each team can run exercises 9 and 10 independently

9. Grant another user query and data manipulation privileges on your COUNTRIES
table. Make sure that the user cannot pass on these privileges to other users.

10. Take back the privileges on the COUNTRIES table granted to another user.
Note: For exercises 11 through 17, team up with another group.

11. Grant another user access to your DEPARTMENTS table. Have the user grant you
query access to his or her DEPARTMENTS table.

12. Query all the rows in your DEPARTMENTS table.

13. Add a new row to your DEPARTMENTS table. Team 1 should add Education as
department number 500. Team 2 should add Human Resources as department
number 510. Query the other teams table.

14. Create a synonym for the other teams DEPARTMENTS table.

15. Query all the rows in the other teams DEPARTMENTS table by using your synonym.
Team 1 SELECT statement results:

16. Revoke the SELECT privilege from the other team.

17. Remove the row that you inserted into the DEPARTMENTS table in step 13 and save
the changes




   
 
 
 


Exemplos
ANALYZE ANY	Analisar qualquer objeto do Banco de Dados, que suporte o comando ANALYZE.	 
AUDIT ANY	Definir opes de Auditoria para qualquer objeto do esquema no Banco de Dados.	 
AUDIT SYSTEM	Auditar as operaes de Sistema (statement e privilgio).	 
CLUSTER (create, create any, alter any, drop any)	Criar, alterar e eliminar qualquer cluster.	 
DATABASE (alter)	Modificar opes do Banco de Dados, atravs do comando ALTER DATABASE	 
DATABASE LINK (create, create public, drop public)	Criar e eliminar vnculos "links" de Banco de Dados.	 
INDEX (create any, alter any, drop anyr)	Criar, alterar e eliminar qualquer ndice.	 
PRIVILEGE (GRANT ANY)	Conceder para si, qualquer privilgio de Sistema.	 
PROCEDURE (create, create any, alter any, drop any, execute any)	Criar, alterar, eliminar e executar pseudo-cdigos armazenados (funes/pacotes) de Banco de Dados.	 
PROFILE (create, alter, drop)	Criar, alterar e eliminar perfis de recursos do Banco de Dados.	 
RESOURCE COST (alter)	Definir custos para recursos de sesso.	 
ROLE (create, alter any, drop any, grant any)	Criar, alterar, eliminar e conceder para si, grupos de personagens.	 
ROLLBACK SEGMENT(create, alter, drop)	Criar, alterar e eliminar segmentos de reconstruo de Banco de Dados.	 
SESSION (create, alter, restricted)	Criar e alterar sesses de Banco de Dados. "RESTRICTED" permite o uso do Banco de Dados como uma sesso restrita.	 
SEQUENCE (create, create any, alter any, drop any, select any)	Criar, alterar, eliminar e usar para si qualquer sequencia de Banco de Dados.	 
SNAPSHOT(create, create any, alter any, drop any)	Criar, alterar e eliminar fotografias de instantneos de Banco de Dados.	 
SYNONYM (create, create any, create public, drop any, drop public)	Criar e eliminar sinnimos pblicos e privados para objetos de Banco de Dados.	 
SYSTEM (alter)	Modificar definies do Servidor de Banco de Dados, atravs do comando ALTER SYSTEM	 
TABLE (create, create any, alter any, backup any, drop any, lock any, comment any, select any, insert any, update any, delete any)	Criar, alterar, copiar, eliminar, bloquear, comentar e manipular qualquer tabela de Banco de Dados. Tambm permite criar ndices, inclusive para restries de integridade.	 
TABLESPACE (create, alter, manage, drop, unlimited)	Criar, alterar, expandir, gerenciar (hot backup), eliminar ou usar espao em tablespaces.	 
TRANSACTION (force, force any)	Gerenciar resultados de transaes distribudas pendentes.	 
TRIGGER (create, create any, alter any, drop any)	Criar, alterar ou eliminar qualquer gatilho de Banco de Dados.	 
USER (create, become, alter, drop)	Criar, alterar ou eliminar usurios de Banco de Dados. BECOME  utilizado para exportaes, atravs do utilitrio EXPORT.	 
VIEW (create, create any, drop any)	Criar ou eliminar qualquer