------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                                              --
--                                                CAPTULO 02 - Administrando Objetos de esquema                                                    --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047

Contedo
  	Add constraints
  	Create indexes
  	Create indexes by using the CREATE TABLE statement
  	Create function-based indexes
  	Drop columns and set columns as UNUSED
  	Perform FLASHBACK operations
  	Create and use external tables


Alter table command

ALTER TABLE employees
ADD (tipo VARCHAR2(9));

desc employees

ALTER TABLE employees
MODIFY (last_name VARCHAR2(30));

ALTER TABLE  employees
DROP COLUMN  tipo;


Unused

select * from user_UNUSED_COL_TABS 

ALTER TABLE  employees
SET   UNUSED (tipo);

ALTER TABLE  employees
DROP  UNUSED COLUMNS;


Constraints

create table emp2 as select * from employees

ALTER TABLE emp2
MODIFY employee_id PRIMARY KEY;

ALTER TABLE emp2
ADD CONSTRAINT emp_mgr_fk FOREIGN KEY(manager_id)  REFERENCES emp2(employee_id);

ALTER TABLE emp2 ADD CONSTRAINT emp_dt_fk
FOREIGN KEY (Department_id)
REFERENCES departments(department_id) ON DELETE CASCADE; -- deleta linha filha

ALTER TABLE emp2 ADD CONSTRAINT emp_dt_fk
FOREIGN KEY (Department_id)
REFERENCES departments(department_id) ON DELETE SET NULL; -- deleta a pai e a filha coloca como nulo


Deferred x Immediate constraint

INITIALLY DEFERRED Checa at o final da transao
INITIALLY IMMEDIATE Checa no final da execuo do comando


ALTER TABLE dept2
ADD CONSTRAINT dept2_id_pk
PRIMARY KEY (department_id)
DEFERRABLE INITIALLY DEFERRED

SET CONSTRAINTS dept2_id_pk IMMEDIATE

ALTER SESSION SET CONSTRAINTS = IMMEDIATE

CREATE TABLE emp_new_sal (salary NUMBER CONSTRAINT sal_ck CHECK (salary > 100) DEFERRABLE INITIALLY DEFERRED,
                          bonus NUMBER CONSTRAINT bonus_ck CHECK (bonus > 0 ) DEFERRABLE INITIALLY DEFERRED );

insert into emp_new_sal values (90, 10);  

commit;

drop table emp_new_sal


Drop constraint

ALTER TABLE emp2
DROP CONSTRAINT emp_mgr_fk; -- primary key, foregn key, not null, check ..

ALTER TABLE dept2
DROP PRIMARY KEY CASCADE; -- elimina a constraint relacionadas

ALTER TABLE emp2
DISABLE CONSTRAINT emp_dt_fk;

ALTER TABLE emp2
ENABLE CONSTRAINT emp_dt_fk;

Cascading Constraint

-- So usadas em DROP COLUMN
-- Dropam todas as colunas definidas como droppped

drop table t1
drop table t2

create table t1 (id number primary Key, nome varchar(50));
create table t2 (id number, valores number(8,2));
alter table t2 add constraint fk_t1_t2 foreign key(id) references t1(id);

select * from t1
select * from t2

alter table t1 drop column id cascade constraint

-- elimina o campo id da tabela t1 e elimina a constraint da tabela t2

Renomeando 
select * from employees

ALTER TABLE employees RENAME COLUMN salario
TO salary;

ALTER TABLE marketing RENAME CONSTRAINT mktg_pk
TO new_mktg_pk;

Indices -- mecanismo que pode dar performance em consultas sql

	Automatically
  	PRIMARY KEY creation
  	UNIQUE KEY creation
	Manually
  	The CREATE INDEX statement
  	The CREATE TABLE statement
  
  
CREATE TABLE NEW_EMP (employee_id NUMBER(6) PRIMARY KEY USING INDEX
                                          (CREATE INDEX emp_id_idx ON
                                          NEW_EMP(employee_id)),
                       first_name  VARCHAR2(20),
                       last_name   VARCHAR2(25));

SELECT INDEX_NAME, TABLE_NAME
FROM   USER_INDEXES
WHERE  TABLE_NAME = 'NEW_EMP';

CREATE INDEX emp_id_idx2 ON NEW_EMP(employee_id);

-- indices baseados em funao

CREATE INDEX upper_dept_name_idx ON departments(UPPER(department_name));

SELECT *
FROM   departments
WHERE  UPPER(department_name) = 'SALES';

-- funo de grupo quebra indices

-- Drop index e table


DROP INDEX upper_dept_name_idx;
DROP TABLE t1 PURGE; -- manda a tabela para uma lixeira.  Acrescentar o comando purge no manda para a lixeira


Operaes de FLASHBACK

Recuperao/Consulta de tabelas em um determinado tempo.


DROP TABLE t1;
DROP TABLE t2 purge;

SELECT original_name, operation, droptime FROM recyclebin;

FLASHBACK TABLE t1 TO BEFORE DROP;

select * from t1;
select * from t2;

PURGE RECYCLEBIN

drop table employees_demo

CREATE TABLE employees_demo
AS SELECT * FROM employees;

SELECT salary
 FROM employees_demo
 WHERE salary < 2500;

UPDATE employees_demo
 SET salary = salary * 1.1
 WHERE salary < 2500;

SELECT salary
 FROM employees_demo
 WHERE salary < 2500;
 
FLASHBACK TABLE employees_demo
 TO TIMESTAMP (SYSTIMESTAMP - INTERVAL '1' minute);

SELECT salary
 FROM employees_demo
 WHERE salary < 2500;

DROP TABLE employees_demo

FLASHBACK TABLE employees_demo TO BEFORE DROP; 

-- Tabelas temporrias

CREATE GLOBAL TEMPORARY TABLE cart
ON COMMIT DELETE ROWS;

CREATE GLOBAL TEMPORARY TABLE today_sales
ON COMMIT PRESERVE ROWS AS
SELECT * FROM orders
WHERE order_date = SYSDATE;

-- Usando tabelas externas

CREATE GLOBAL TEMPORARY TABLE today_sales
ON COMMIT PRESERVE ROWS AS
SELECT * FROM orders
WHERE order_date = SYSDATE;


CREATE TABLE oldemp (
          fname char(25), lname CHAR(25))
          ORGANIZATION EXTERNAL
          (TYPE ORACLE_LOADER
          DEFAULT DIRECTORY emp_dir
          ACCESS PARAMETERS
          (RECORDS DELIMITED BY NEWLINE
           NOBADFILE
           NOLOGFILE
           FIELDS TERMINATED BY ','
              (fname POSITION ( 1:20) CHAR,
               lname POSITION (22:41) CHAR))
          LOCATION ('emp.dat'))
          PARALLEL 5
          REJECT LIMIT 200;


-- tabelas externas usando datapump

CREATE TABLE emp_ext
(employee_id, first_name, last_name)
ORGANIZATION EXTERNAL
(
TYPE ORACLE_DATAPUMP
DEFAULT DIRECTORY emp_dir
LOCATION
('emp1.exp','emp2.exp')
)
PARALLEL
AS
SELECT employee_id, first_name, last_name
FROM   employees;

-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos

1. Create the DEPT2 table based on the following table instance. Enter the syntax
in the SQL Worksheet. Then, execute the statement to create the table. Confirm that
the table is created. Coluns ID number(7) and name varchar(25)

2. Populate the DEPT2 table with data from the DEPARTMENTS table. Include only the
columns that you need.

3. Create the EMP2 table based on the following table instance . Enter the syntax in
the SQL Worksheet. Then execute the statement to create the table. Confirm that the
table is created. 
Columns
id NUMBER(7), last_name  VARCHAR2(25), first_name  VARCHAR2(25), dept_id NUMBER(7)

4. Modify the EMP2 table to allow for longer employee last names. Confirm your
modification. 50 caracteres minimo

5. Create the EMPLOYEES2 table based on the structure of the EMPLOYEES table.
Include only the EMPLOYEE_ID, FIRST_NAME, LAST_NAME, SALARY, and
DEPARTMENT_ID columns. Name the columns in your new table ID,
FIRST_NAME, LAST_NAME, SALARY, and DEPT_ID, respectively.


6. Drop the EMP2 table.


7. Query the recycle bin to see whether the table is present.


8. Restore the EMP2 table to a state before the DROP statement. 

9. Drop the FIRST_NAME column from the EMPLOYEES2 table. Confirm your
modification by checking the description of the table.


10. In the EMPLOYEES2 table, mark the DEPT_ID column as UNUSED. Confirm your
modification by checking the description of the table.
 

11. Drop all the UNUSED columns from the EMPLOYEES2 table. Confirm your
modification by checking the description of the table.


12. Add a table-level PRIMARY KEY constraint to the EMP2 table on the ID column. The  
constraint should be named at creation. Name the constraint my_emp_id_pk.

13. Create a PRIMARY KEY constraint to the DEPT2 table using the ID column. The
constraint should be named at creation. Name the constraint my_dept_id_pk.


14. Add a foreign key reference on the EMP2 table that ensures that the employee is not
assigned to a nonexistent department. Name the constraint my_emp_dept_id_fk.  

15. Modify the EMP2 table. Add a COMMISSION column of the NUMBER data type,
precision 2, scale 2. Add a constraint to the COMMISSION column that ensures that a 
commission value is greater than zero.

16. Drop the EMP2 and DEPT2 tables so that they cannot be restored. Check in the
recycle bin. 

17. Create the DEPT_NAMED_INDEX table based on the following table instance.
Name the index for the PRIMARY KEY column as DEPT_PK_IDX. Columns deptno number 4,
dname varchar(30). Create index in time creation of table

18. Create an external table library_items_ext. Use the ORACLE_LOADER access.
Create file dados.dat in directory and insert :

2354,    2264, 13.21, 150,
2355,    2289, 46.23, 200,
2355,    2264, 50.00, 100,

19. Create the emp_books table and populate it with data. Set the primary key as
deferred and observe what happens at the end of the transaction.
book_id number, title varchar2(20) and book_id is primarykey

insert in the table values 
300,'Organizations'
300,'Change Management'

Set the emp_books_pk constraint as deferred

Drop the emp_books_pk constraint.

Modify the emp_books table definition to add the emp_books_pk
constraint as deferrable this time.

Set the emp_books_pk constraint as deferred.

Insert int the table
300,'Change Management'
300,'Personality'
350,'Creativity'






















