------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                                              --
--                                             CAPTULO 04 - Manipulao de grandes conjuntos de dados                                                    --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047


	Manipulate data by using subqueries
	Specify explicit default values in the INSERT and UPDATE statements
	Describe the features of multitable INSERTs
	Use the following types of multitable INSERTs:
    	Unconditional INSERT
    	Pivoting INSERT
    	Conditional INSERT ALL
    	Conditional INSERT FIRST
	Merge rows in a table
	Track the changes to data over a period of time

-- Recuperando dados usando subquery

SELECT department_name, city
FROM   departments
NATURAL JOIN (SELECT l.location_id, l.city, l.country_id
              FROM   loc l
              JOIN   countries c
              ON(l.country_id = c.country_id)
              JOIN regions USING(region_id)
              WHERE region_name = 'Europe');


-- joins com views
CREATE OR REPLACE VIEW european_cities
AS
      SELECT l.location_id, l.city, l.country_id
      FROM   loc l
      JOIN   countries c
      ON(l.country_id = c.country_id)
      JOIN regions USING(region_id)
      WHERE region_name =	'Europe'

SELECT department_name, city
FROM   departments
NATURAL JOIN european_cities;  -- posso fazer joins apontando para views

-- insert com subquery
INSERT INTO (SELECT l.location_id, l.city, l.country_id
              FROM   locations l  -- aqui vai ser realizado o insert, table
              JOIN   countries c
              ON(l.country_id = c.country_id)
              JOIN regions USING(region_id)
              WHERE region_name = 'Europe')
VALUES (3400, 'Cardiff', 'UK');

select * from locations

-- Insert com with check option

INSERT INTO (SELECT location_id, city, country_id
              FROM   loc -- esta  a tabela que vai sobrer o insert
              WHERE  country_id IN
                                  (SELECT country_id 
                                   FROM countries
                                   NATURAL JOIN regions
                                   WHERE region_name =	'Europe') -- valida as condies
              WITH CHECK OPTION)
VALUES (3600,	'Washington',	'US');

-- inserindo validando o with check option
INSERT INTO (SELECT location_id, city, country_id
              FROM   loc -- esta  a tabela que vai sobrer o insert
              WHERE  country_id IN
                                  (SELECT country_id 
                                   FROM countries
                                   NATURAL JOIN regions
                                   WHERE region_name =	'Europe')
              WITH CHECK OPTION)
VALUES (3800,	'Berlin',	'DE');

-- Insert com valores nulos
drop table deptm3
create table deptm3 (department_id number(4), department_name varchar(45), manager_id number );

INSERT INTO deptm3 (department_id, department_name, manager_id)
VALUES (300, 'Engineering', DEFAULT);

select * from deptm3

-- Update com valores nulos

UPDATE deptm3
SET manager_id = DEFAULT
WHERE department_id = 10;

-- Copiando linhas de outras tabelas

drop table sapes_rape
create table sapes_rape as select * from employees

INSERT INTO sapes_rape(employee_id, last_name, salary, commission_pct, email, hire_date, job_id)
              SELECT employee_id, last_name, salary, commission_pct, email, hire_date, job_id
              FROM   employees
              WHERE  job_id LIKE '%REP%';
              
              

-- Multiple table INSERT
  	Unconditional INSERT
  	Conditional INSERT ALL
  	Pivoting INSERT
  	Conditional INSERT FIRST


-- criao das tabelas para exemplo
drop table sal_history
create table sal_history as select employee_id, hire_date, salary from employees;
drop table mgr_history;
create table mgr_history as select employee_id, manager_id, salary from employees;
drop table emp_history;
create table emp_history as select employee_id, hire_date, salary from employees;
drop table emp_sales;
create table emp_sales as select employee_id, COMMISSION_PCT, salary from employees;


select * from sal_history;
select * from mgr_history;
select * from emp_sales;
select * from emp_history;


-- Unconditional INSERT ALL

INSERT  ALL
  INTO sal_history VALUES(EMPID,HIREDATE,SAL)
  INTO mgr_history VALUES(EMPID,MGR,SAL)
      SELECT employee_id EMPID, hire_date HIREDATE, salary SAL, manager_id MGR
      FROM  employees
      WHERE employee_id > 200;
      
-- Outro Exemplo

drop table t1
CREATE TABLE t1
    ( owner       VARCHAR2(30)
    , object_name VARCHAR2(30)
    , object_type VARCHAR2(30)
    , object_id   NUMBER
    , created     DATE
    );

drop table t2;
CREATE TABLE t2 AS SELECT * FROM t1;
CREATE TABLE t3 AS SELECT * FROM t1;
CREATE TABLE t4 AS SELECT * FROM t1;

SELECT COUNT(*) FROM all_objects;

INSERT ALL
       INTO t1
       INTO t2
       INTO t3
       INTO t4
    SELECT owner
    ,      object_type
    ,      object_name
    ,      object_id
   ,      created
   FROM   all_objects;
   
   select * from t1
   select * from t2
   select * from t3
   select * from t4


-- Conditional Insert All

INSERT  ALL
  WHEN HIREDATE <	'01-JAN-95'	THEN
    INTO emp_history VALUES(EMPID,HIREDATE,SAL)
  WHEN COMM IS NOT NULL THEN
    INTO emp_sales VALUES(EMPID,COMM,SAL)
SELECT employee_id EMPID, hire_date HIREDATE, salary SAL, commission_pct COMM
FROM  employees

delete from t1
delete from t2

 INSERT ALL
       --<>--
       WHEN 1 = 1 
       THEN
       INTO t1 (owner, object_name)  --<-- unconditional
       VALUES  (owner, object_name)
       --<>--
       WHEN object_type = 'TABLE'    --<-- conditional
       THEN
          INTO t2 (owner, object_name, object_type)
          VALUES  (owner, object_name, object_type)
      --<>--
   SELECT owner
   ,      object_type
   ,      object_name
   ,      object_id
   ,      created
   FROM   all_objects

select * from t1
select * from t2

-- Conditional insert first

INSERT FIRST
WHEN salary < 5000 THEN
  INTO sal_low VALUES (employee_id, last_name, salary)
WHEN salary between 5000 and 10000 THEN
  INTO sal_mid VALUES (employee_id, last_name, salary)
ELSE
  INTO sal_high VALUES (employee_id, last_name, salary)
SELECT employee_id, last_name, salary
FROM employees

delete from t1;
delete from t2;
delete from t3;
delete from t4;

 INSERT FIRST  -- avalia a primeira condio se for verdade no avalia as demais
       --<>--
       WHEN owner = 'SYSTEM'
       THEN
          INTO t1 (owner, object_name)
          VALUES  (owner, object_name)
       --<>--
       WHEN object_type = 'TABLE'
       THEN
         INTO t2 (owner, object_name, object_type)
         VALUES  (owner, object_name, object_type)
      --<>--
      WHEN object_name LIKE 'DBMS%'
      THEN
         INTO t3 (owner, object_name, object_type)
         VALUES  (owner, object_name, object_type)
      --<>--
      ELSE
         INTO t4 (owner, object_type, object_name, created, object_id)
         VALUES  (owner, object_type, object_name, created, object_id)
      --<>--
   SELECT owner
   ,      object_type
   ,      object_name
   ,      object_id
   ,      created
   FROM   all_objects;


select * from t1
select * from t2
select * from t3
select * from t4

-- Pivoting Insert

Ver imagem dentro pasta sqlexpert pivoting.jpg

INSERT ALL
    INTO sales_info VALUES (employee_id,week_id,sales_MON)
    INTO sales_info VALUES (employee_id,week_id,sales_TUE)
    INTO sales_info VALUES (employee_id,week_id,sales_WED)
    INTO sales_info VALUES (employee_id,week_id,sales_THUR)
    INTO sales_info VALUES (employee_id,week_id, sales_FRI)
SELECT EMPLOYEE_ID, week_id, sales_MON, sales_TUE, sales_WED, sales_THUR,sales_FRI 
FROM sales_source_data;


-- Merge
create table copy_emp3 as select * from employees
delete from copy_emp3

MERGE INTO copy_emp3 c
USING (SELECT * FROM EMPLOYEES) e
ON (c.employee_id = e.employee_id)

WHEN MATCHED THEN
UPDATE SET
c.first_name = e.first_name,
c.last_name = e.last_name
--...
-- DELETE WHERE (E.COMMISSION_PCT IS NOT NULL)
WHEN NOT MATCHED THEN
INSERT VALUES(e.employee_id, e.first_name, e.last_name,
e.email, e.phone_number, e.hire_date, e.job_id,
e.salary, e.commission_pct, e.manager_id,
e.department_id);

select * from copy_emp3


-- Flashback Query
drop table employees3
create table employees3 as select * from employees

SELECT salary FROM employees3
WHERE  employee_id = 107;

UPDATE employees3 SET salary = salary * 1.30
WHERE  employee_id = 107;

COMMIT;

SELECT salary FROM employees3
VERSIONS BETWEEN SCN MINVALUE AND MAXVALUE
WHERE  employee_id = 107;  -- buscando informaes de undo



-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos
       
1. Create the SAL_HISTORY table.  

2. Display the structure of the SAL_HISTORY table.

3. Create the MGR_HISTORY table.

4. Display the structure of the MGR_HISTORY table.

5. Create the SPECIAL_SAL table.

6. Display the structure of the SPECIAL_SAL table.

7. a) Write a query to do the following:
  -	Retrieve details such as the employee ID, hire date, salary, and manager ID
  of those employees whose employee ID is less than 125 from the
  EMPLOYEES table.
  -	If the salary is more than $20,000, insert details such as the employee ID
  and salary into the SPECIAL_SAL table.
  -	Insert details such as the employee ID, hire date, and salary into the
  SAL_HISTORY table.
  -	Insert details such as the employee ID, manager ID, and salary into the
  MGR_HISTORY table.
  
1. Create the SAL_HISTORY
table.  

Execute : create table sal_history (empid, hire_date, sal) as select employee_id, hire_date, salary from employees

2. Display the structure of the SAL_HISTORY table.

3. Create the MGR_HISTORY table.

Execute : create table MGR_HISTORY (empid, mrg, sal) as select employee_id, manager_id, salary from employees

4. Display the structure of the MGR_HISTORY table.

5. Create the SPECIAL_SAL table.

Execute : create table SPECIAL_SAL (empid, sal) as select employee_id, salary from employees

6. Display the structure of the SPECIAL_SAL table.

7. a) Write a query to do the following:
    -	Retrieve details such as the employee ID, hire date, salary, and manager ID
    of those employees whose employee ID is less than 125 from the
    EMPLOYEES table.
    -	If the salary is more than $20,000, insert details such as the employee ID
    and salary into the SPECIAL_SAL table.
    -	Insert details such as the employee ID, hire date, and salary into the
    SAL_HISTORY table.
    -	Insert details such as the employee ID, manager ID, and salary into the
    MGR_HISTORY table.


08) Merge the data in the SAL_HISTORY table created in the last lab into the data in
the employees table. Assume that the data in the external employees table
is the most up-to-date. If a row in the employees table matches the
SAL_HISTORY table, update the email column of the EMP_HIST table to match
the employees table row. If a row in the employees table does not match,
insert it into the EMP_HIST table. Rows are considered matching when the
employees first and last names are identical.  



    

  
       
       
       


