------------------------------------------------------------------------------------------------------------------------------------------------------
--                                       TREINAMENTO ORACLE - PROVA DE CERTIFICAO 1Z0-047 SQL EXPERT Oracle 10g 11g 12c                                              --
--                                             CAPTULO 05 - Administrando dados em diferentes TIME ZONES                                                    --
--                                                            INSTRUTOR PEDRO F. CARVALHO                                                           --
--                                                             WWW.PEDROFCARVALHO.COM.BR                                                            --
--                                                           CONTATO@PEDROFCARVALHO.COM.BR                                                          -- 
------------------------------------------------------------------------------------------------------------------------------------------------------
Links
http:/education.oracle.com/pls/web_prod-plq-dad/db_pages.getpage?page_id=5001&get_params=p_exam_id:1Z0-047


	Use data types similar to DATE that store fractional seconds and track time zones
	Use data types that store the difference between two datetime values
	Use the following datetime functions:
 
	CURRENT_DATE
	CURRENT_TIMESTAMP
	LOCALTIMESTAMP
	DBTIMEZONE
	SESSIONTIMEZONE
	EXTRACT
 	TZ_OFFSET
	FROM_TZ
	TO_TIMESTAMP
	TO_YMINTERVAL
	TO_DSINTERVAL


-- parametro TIME_ZONE

ALTER SESSION SET TIME_ZONE = '-05:00';
ALTER SESSION SET TIME_ZONE = dbtimezone;
ALTER SESSION SET TIME_ZONE = local;
ALTER SESSION SET TIME_ZONE = 'America/New_York';

-- CURRENT_DATE, CURRENT_TIMESTAMP E LOCALTIMESTAMP

ALTER SESSION SET NLS_DATE_FORMAT = 'DD-MON-YYYY HH24:MI:SS';

ALTER SESSION SET TIME_ZONE = '-5:00';
 
SELECT SESSIONTIMEZONE, CURRENT_DATE FROM DUAL; -- sempre vai mostrar a data da sesso do usuarios
-- 11-JUN-2015 23:55:29
SELECT SESSIONTIMEZONE, CURRENT_TIMESTAMP FROM DUAL;
--11/06/15 23:55:38,029000000 -05:00
SELECT SESSIONTIMEZONE, LOCALTIMESTAMP FROM DUAL;
-- 11/06/15 23:55:50,862000000

Monstra o valor da regio onde o banco esta instalado

SELECT DBTIMEZONE FROM DUAL;  -- onde o banco esta

Mostra o valor da sesso aonde o usurio esta logado

SELECT SESSIONTIMEZONE FROM DUAL; -- a minha sesso


-- diferena entre date e timestamp

SELECT hire_date
FROM employees;
-- 05-JUN-2015 22:48:06

ALTER TABLE employees
MODIFY hire_date TIMESTAMP;

SELECT hire_date
FROM employees;

--05/06/15 22:48:06,000000000

-- comparando timestamp 

CREATE TABLE web_orders
(order_date TIMESTAMP WITH TIME ZONE,
delivery_time TIMESTAMP WITH LOCAL TIME ZONE);

INSERT INTO web_orders values
(current_date, current_timestamp + 2);

SELECT * FROM web_orders;

-- interval data types year to month

CREATE TABLE warranty
(prod_id number,  warranty_time INTERVAL YEAR(3) TO MONTH);

INSERT INTO warranty VALUES (123, INTERVAL '8' MONTH);
INSERT INTO warranty VALUES (155, INTERVAL '200' YEAR(3));
INSERT INTO warranty VALUES (678, '200-11');

SELECT * FROM warranty;


-- intervar day to second

CREATE TABLE lab
( exp_id number, test_time INTERVAL DAY(2) TO SECOND);

INSERT INTO lab VALUES (100012, '90 00:00:00');
INSERT INTO lab VALUES (56098, INTERVAL '6 03:30:16' DAY	TO SECOND);

SELECT * FROM lab;


-- funo extract
SELECT EXTRACT (YEAR FROM SYSDATE) FROM DUAL;
select to_char(sysdate, 'YYYY') FROM DUAL

SELECT last_name, hire_date,
EXTRACT (MONTH FROM HIRE_DATE)
FROM employees
WHERE manager_id = 100;

-- funo tz_offset

SELECT TZ_OFFSET('US/Eastern'),
TZ_OFFSET('Canada/Yukon'),
TZ_OFFSET('Europe/London')
FROM DUAL;


-- funo FROM_TZ

SELECT FROM_TZ(TIMESTAMP'2000-07-12 08:00:00' , 'Australia/North')
FROM DUAL;


-- funo TO_TIMESTAMP

SELECT TO_TIMESTAMP ('2007-03-06 11:00:00', 'YYYY-MM-DD HH:MI:SS')    
FROM DUAL;

-- funo TO_YMINTERVAL

SELECT hire_date,
hire_date + TO_YMINTERVAL('01-02') AS HIRE_DATE_YMININTERVAL
FROM   employees
WHERE department_id = 20;


-- funo TO_DSINTERVAL

SELECT last_name,
TO_CHAR(hire_date, 'mm-dd-yy:hh:mi:ss') hire_date,
TO_CHAR(hire_date + TO_DSINTERVAL('100 10:00:00'), 
'mm-dd-yy:hh:mi:ss') hiredate2
FROM employees;


-- Passos de estudos
-- 1 - Assitir a video aula somente observando 2x
-- 2 - Assitir a video aula agora fazendo os scritps 2x
-- 3 - Acessar pasta exerccios e dar uma olhada nos exerccios
-- 4 - Realizar os exerccios de fixao abaixo e encaminhar os selects no meu email
       -- Obs : Premio para quem acertar todos




1.   Alter the session to set NLS_DATE_FORMAT to DD-MON-YYYY HH24:MI:SS.


2. a.   Write queries to display the time zone offsets (TZ_OFFSET) for the following
time zones: US/Pacific-New, Singapore, and Egypt.

US/Pacific-New
Singapore
Egypt


b. Alter the session to set the TIME_ZONE parameter value to the time zone offset
of US/Pacific-New.

c. Display CURRENT_DATE, CURRENT_TIMESTAMP, and LOCALTIMESTAMP
for this session.
Note: The output may be different based on the date when the command is
executed.

d. Alter the session to set the TIME_ZONE parameter value to the time zone offset
of Singapore.


e. Display CURRENT_DATE, CURRENT_TIMESTAMP, and LOCALTIMESTAMP
for this session.
Note: The output might be different, based on the date when the command is
executed.

Note: Observe in the preceding practice that CURRENT_DATE,
CURRENT_TIMESTAMP, and LOCALTIMESTAMP are all sensitive to the session
time zone.

3.   Write a query to display DBTIMEZONE and SESSIONTIMEZONE.

4.   Write a query to extract YEAR from the HIRE_DATE column of the EMPLOYEES
table for those employees who work in department 80.

5. Alter the session to set NLS_DATE_FORMAT to DD-MON-YYYY.

6. Examine and run the lab_05_06.sql script to create the SAMPLE_DATES table
and populate it.

a. Select from the table and view the data.  

b. Modify the data type of the DATE_COL column and change it to TIMESTAMP.
Select from the table to view the data.  

c. Try to modify the data type of the DATE_COL column and change it to
TIMESTAMP WITH TIME ZONE. What happens? 

7. Create a query to retrieve last names from the EMPLOYEES table and calculate the
review status. If the year hired was 1998, display Needs Review for the review
status; otherwise, display not this year! Name the review status column 
Review. Sort the results by the HIRE_DATE column.
Hint: Use a CASE expression with the EXTRACT function to calculate the review
status.

8. Create a query to print the last names and the number of years of service for each
employee. If the employee has been employed five or more years, print 5 years of
service. If the employee has been employed 10 or more years, print 10 years
of service. If the employee has been employed 15 or more years, print 15 years
of service. If none of these conditions match, print maybe next year! Sort
the results by the HIRE_DATE column. Use the EMPLOYEES table.
Hint: 
Use CASE expressions and TO_YMINTERVAL.


